
;CodeVisionAVR C Compiler V1.25.9 Professional
;(C) Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega16
;Program type           : Application
;Clock frequency        : 8,000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 256 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : No
;Word align FLASH struct: Yes
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega16
	#pragma AVRPART MEMORY PROG_FLASH 16384
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	LDI  R23,BYTE4(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "main.vec"
	.INCLUDE "main.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x400)
	LDI  R25,HIGH(0x400)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x45F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x45F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x160)
	LDI  R29,HIGH(0x160)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160
;       1 /*****************************************************
;       2 Project   : IO-050 PPS Breakout Box 7s
;       3 Version   : 0.1
;       4 Date       : --.11.2008
;       5 
;       6 Author   : Oleg D.
;       7 
;       8 Chip type                   : ATmega16
;       9 Clock frequency        : 8 MHz
;      10 Memory model           : Tiny
;      11 External SRAM size  : 0
;      12 Data Stack size        : 32
;      13 *****************************************************/
;      14 
;      15 #include <mega16.h>
;      16 	#ifndef __SLEEP_DEFINED__
	#ifndef __SLEEP_DEFINED__
;      17 	#define __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
;      18 	.EQU __se_bit=0x40
	.EQU __se_bit=0x40
;      19 	.EQU __sm_mask=0xB0
	.EQU __sm_mask=0xB0
;      20 	.EQU __sm_powerdown=0x20
	.EQU __sm_powerdown=0x20
;      21 	.EQU __sm_powersave=0x30
	.EQU __sm_powersave=0x30
;      22 	.EQU __sm_standby=0xA0
	.EQU __sm_standby=0xA0
;      23 	.EQU __sm_ext_standby=0xB0
	.EQU __sm_ext_standby=0xB0
;      24 	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_adc_noise_red=0x10
;      25 	.SET power_ctrl_reg=mcucr
	.SET power_ctrl_reg=mcucr
;      26 	#endif
	#endif
;      27 #include <delay.h>
;      28 
;      29 #define M_PPS PORTB.7 // PPS
;      30 #define PPS PIND.2    // PPS
;      31 
;      32 #define BUTTON PIND.3 //
;      33 
;      34 #define SEGMENT_7 PORTB //  
;      35 
;      36 #define a 1   //    ,  ,
;      37 #define b 2   //   ,   "" 
;      38 #define c 4   // ,      
;      39 #define d 8 //   .  ,  
;      40 #define e 16  // -   ,    
;      41 #define f 32  //  255     .
;      42 #define g 64  //        .
;      43 #define pt 128 //
;      44 
;      45 unsigned char dig[16]; /* ,    ,       ,   
;      46     .     */
_dig:
	.BYTE 0x10
;      47 
;      48 char i, k; //i -   , k -     
;      49 
;      50 bit j; //  pps
;      51 
;      52 void __io_init () //  /
;      53 {

	.CSEG
___io_init:
;      54 DDRA = 0b000; //  
	LDI  R30,LOW(0)
	OUT  0x1A,R30
;      55 PORTA = 0b111;
	LDI  R30,LOW(7)
	OUT  0x1B,R30
;      56 
;      57 DDRB = 0b01111111; //    
	LDI  R30,LOW(127)
	OUT  0x17,R30
;      58 SEGMENT_7 = dig[0];
	LDS  R30,_dig
	OUT  0x18,R30
;      59 
;      60 DDRD = 0b1000000; //   PORTD.6 -   
	LDI  R30,LOW(64)
	OUT  0x11,R30
;      61 PORTD = 0b1111111;
	LDI  R30,LOW(127)
	OUT  0x12,R30
;      62 
;      63 // Analog Comparator initialization
;      64 // Analog Comparator: Off
;      65 // Analog Comparator Input Capture by Timer/Counter 1: Off
;      66 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;      67 }
	RET
;      68 
;      69 void __dig_init () //   
;      70 {
___dig_init:
;      71   dig[0] = a + b + c + d + e + f;   //     ,
	LDI  R30,LOW(63)
	STS  _dig,R30
;      72   dig[1] = b + c;           //     
	LDI  R30,LOW(6)
	__PUTB1MN _dig,1
;      73   dig[2] = a + b + g + e + d;     // 255.    , 
	LDI  R30,LOW(91)
	__PUTB1MN _dig,2
;      74   dig[3] = a + b + g + c + d;     //   .
	LDI  R30,LOW(79)
	__PUTB1MN _dig,3
;      75   dig[4] = f + g + b + c;       //   
	LDI  R30,LOW(102)
	__PUTB1MN _dig,4
;      76   dig[5] = a + f + g + c + d;     //   
	LDI  R30,LOW(109)
	__PUTB1MN _dig,5
;      77   dig[6] = a + f + g + c + d + e;
	LDI  R30,LOW(125)
	__PUTB1MN _dig,6
;      78   dig[7] = a + b + c;
	LDI  R30,LOW(7)
	__PUTB1MN _dig,7
;      79   dig[8] = a + b + c + d + e + f + g;
	LDI  R30,LOW(127)
	__PUTB1MN _dig,8
;      80   dig[9] = a + b + c + d + f + g;
	LDI  R30,LOW(111)
	__PUTB1MN _dig,9
;      81   dig[10] = 119; //A
	LDI  R30,LOW(119)
	__PUTB1MN _dig,10
;      82   dig[11] = 124; //B
	LDI  R30,LOW(124)
	__PUTB1MN _dig,11
;      83   dig[12] = 57;  //C
	LDI  R30,LOW(57)
	__PUTB1MN _dig,12
;      84   dig[13] = 94;  //D
	LDI  R30,LOW(94)
	__PUTB1MN _dig,13
;      85   dig[14] = 121; //E
	LDI  R30,LOW(121)
	__PUTB1MN _dig,14
;      86   dig[15] = 113; //F
	LDI  R30,LOW(113)
	__PUTB1MN _dig,15
;      87  }
	RET
;      88 
;      89 void __segment_7 (char x) //x    < 16,     
;      90 {
___segment_7:
;      91  SEGMENT_7 = SEGMENT_7 & 0b10000000; //  
;	x -> Y+0
	IN   R30,0x18
	ANDI R30,LOW(0x80)
	OUT  0x18,R30
;      92 
;      93  SEGMENT_7 = SEGMENT_7 | dig [x]; // 
	IN   R30,0x18
	MOV  R26,R30
	LD   R30,Y
	LDI  R31,0
	SUBI R30,LOW(-_dig)
	SBCI R31,HIGH(-_dig)
	LD   R30,Z
	OR   R30,R26
	OUT  0x18,R30
;      94  } //-----------------------------------------------------------------------------------------------------------------------------------
	ADIW R28,1
	RET
;      95 
;      96 void __segment_7_off ()
;      97 {
___segment_7_off:
;      98  SEGMENT_7 = SEGMENT_7 & 0b10000000; //  
	IN   R30,0x18
	ANDI R30,LOW(0x80)
	OUT  0x18,R30
;      99  }
	RET
;     100 
;     101 char __routine (char x) //  
;     102 {
___routine:
;     103 
;     104 char k_l; //k_l-     
;     105 
;     106 switch (x)
	ST   -Y,R17
;	x -> Y+1
;	k_l -> R17
	LDD  R30,Y+1
;     107        {
;     108         case 0: DDRB.7 = 0; //  - M_PPS  z 
	CPI  R30,0
	BRNE _0x6
	CBI  0x17,7
;     109 				__segment_7 (0);
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL ___segment_7
;     110 		break;
	RJMP _0x5
;     111 
;     112 		case 1: __segment_7 (1);
_0x6:
	CPI  R30,LOW(0x1)
	BRNE _0x9
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL ___segment_7
;     113 		break;
	RJMP _0x5
;     114 
;     115 		case 2: __segment_7 (2);
_0x9:
	CPI  R30,LOW(0x2)
	BRNE _0xA
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL ___segment_7
;     116 		break;
	RJMP _0x5
;     117 
;     118 		case 3: __segment_7 (3);
_0xA:
	CPI  R30,LOW(0x3)
	BRNE _0xB
	LDI  R30,LOW(3)
	ST   -Y,R30
	RCALL ___segment_7
;     119 		break;
	RJMP _0x5
;     120 
;     121 		case 4: __segment_7 (4);
_0xB:
	CPI  R30,LOW(0x4)
	BRNE _0xC
	LDI  R30,LOW(4)
	ST   -Y,R30
	RCALL ___segment_7
;     122 		break;
	RJMP _0x5
;     123 
;     124 		case 5: __segment_7 (5);
_0xC:
	CPI  R30,LOW(0x5)
	BRNE _0xD
	LDI  R30,LOW(5)
	ST   -Y,R30
	RCALL ___segment_7
;     125 		break;
	RJMP _0x5
;     126 
;     127 		case 6: __segment_7 (6);
_0xD:
	CPI  R30,LOW(0x6)
	BRNE _0xE
	LDI  R30,LOW(6)
	ST   -Y,R30
	RCALL ___segment_7
;     128 		break;
	RJMP _0x5
;     129 
;     130 		case 7: __segment_7 (7);
_0xE:
	CPI  R30,LOW(0x7)
	BRNE _0xF
	LDI  R30,LOW(7)
	ST   -Y,R30
	RCALL ___segment_7
;     131 		break;
	RJMP _0x5
;     132 
;     133 		case 8: DDRB.7 = 1; //  - M_PPS - 
_0xF:
	CPI  R30,LOW(0x8)
	BRNE _0x10
	SBI  0x17,7
;     134 
;     135 				__segment_7 (8);
	LDI  R30,LOW(8)
	ST   -Y,R30
	RCALL ___segment_7
;     136 
;     137 				OCR0=0x4F; //    79 0x4f
	LDI  R30,LOW(79)
	OUT  0x3C,R30
;     138 				k_l = 0x01; //    19,68 
	LDI  R17,LOW(1)
;     139 		break;
	RJMP _0x5
;     140 
;     141 		case 9: __segment_7 (9);
_0x10:
	CPI  R30,LOW(0x9)
	BRNE _0x13
	LDI  R30,LOW(9)
	ST   -Y,R30
	RCALL ___segment_7
;     142 
;     143 				OCR0=0x32; //    50 0x32
	LDI  R30,LOW(50)
	OUT  0x3C,R30
;     144 				k_l = 0x02; //    19,68/8 
	LDI  R17,LOW(2)
;     145 		break;
	RJMP _0x5
;     146 
;     147 		case 10: __segment_7 (10);
_0x13:
	CPI  R30,LOW(0xA)
	BRNE _0x14
	LDI  R30,LOW(10)
	ST   -Y,R30
	RCALL ___segment_7
;     148 
;     149 				 OCR0=0x63; //    99 0x63
	LDI  R30,LOW(99)
	OUT  0x3C,R30
;     150 				 k_l = 0x02; //    19,68/8 
	LDI  R17,LOW(2)
;     151 		break;
	RJMP _0x5
;     152 
;     153 		case 11: __segment_7 (11);
_0x14:
	CPI  R30,LOW(0xB)
	BRNE _0x15
	LDI  R30,LOW(11)
	ST   -Y,R30
	RCALL ___segment_7
;     154 
;     155 				 OCR0=0x94; //    148 0x94
	LDI  R30,LOW(148)
	OUT  0x3C,R30
;     156 				 k_l = 0x02; //    19,68/8 
	LDI  R17,LOW(2)
;     157 		break;
	RJMP _0x5
;     158 
;     159 		case 12: __segment_7 (12);
_0x15:
	CPI  R30,LOW(0xC)
	BRNE _0x16
	LDI  R30,LOW(12)
	ST   -Y,R30
	RCALL ___segment_7
;     160 
;     161 				 OCR0=0xC7; //    199 0x7
	LDI  R30,LOW(199)
	OUT  0x3C,R30
;     162 				 k_l = 0x02; //    19,68/8 
	LDI  R17,LOW(2)
;     163 		break;
	RJMP _0x5
;     164 
;     165 		case 13: __segment_7 (13);
_0x16:
	CPI  R30,LOW(0xD)
	BRNE _0x17
	LDI  R30,LOW(13)
	ST   -Y,R30
	RCALL ___segment_7
;     166 
;     167 				 OCR0=0xF8; //    248 0xF8
	LDI  R30,LOW(248)
	OUT  0x3C,R30
;     168 				 k_l = 0x02; //    19,68/8 
	LDI  R17,LOW(2)
;     169 		break;
	RJMP _0x5
;     170 
;     171 		case 14: __segment_7 (14);
_0x17:
	CPI  R30,LOW(0xE)
	BRNE _0x18
	LDI  R30,LOW(14)
	ST   -Y,R30
	RCALL ___segment_7
;     172 
;     173 				 OCR0=0x25; //    37 0x25
	LDI  R30,LOW(37)
	RJMP _0x28
;     174 				 k_l = 0x03;; //    19,68/64 
;     175 		break;
;     176 
;     177 		case 15: __segment_7 (15);
_0x18:
	CPI  R30,LOW(0xF)
	BRNE _0x5
	LDI  R30,LOW(15)
	ST   -Y,R30
	RCALL ___segment_7
;     178 
;     179 				 OCR0=0x2B; //    43 0x2B
	LDI  R30,LOW(43)
_0x28:
	OUT  0x3C,R30
;     180 				 k_l = 0x03;; //    19,68/64 
	LDI  R17,LOW(3)
;     181 		break;
;     182 		};
_0x5:
;     183 
;     184 return k_l;
	MOV  R30,R17
	LDD  R17,Y+0
	ADIW R28,2
	RET
;     185 }
;     186 
;     187 void __interrupt_init ()
;     188 {
___interrupt_init:
;     189 // External Interrupt(s) initialization
;     190 // INT0: On
;     191 // INT0 Mode: Rising Edge
;     192 // INT1: Off
;     193 // INT2: Off
;     194 GICR|=0x40;
	IN   R30,0x3B
	ORI  R30,0x40
	OUT  0x3B,R30
;     195 MCUCR=0x03;
	LDI  R30,LOW(3)
	OUT  0x35,R30
;     196 MCUCSR=0x00;
	LDI  R30,LOW(0)
	OUT  0x34,R30
;     197 GIFR=0x40;
	LDI  R30,LOW(64)
	OUT  0x3A,R30
;     198 
;     199 TIMSK = 0b00010010; //    / 0   /1
	LDI  R30,LOW(18)
	OUT  0x39,R30
;     200 
;     201 TCNT1H = 0; //  
	RCALL SUBOPT_0x0
;     202 TCNT1L = 0;
;     203 
;     204 OCR1AH = 0x20; //    8203 0x200b (1,05 c)
	LDI  R30,LOW(32)
	OUT  0x2B,R30
;     205 OCR1AL = 0x0b;
	LDI  R30,LOW(11)
	OUT  0x2A,R30
;     206 
;     207 TCCR1B = 0b00000101; //    8/1024 
	LDI  R30,LOW(5)
	OUT  0x2E,R30
;     208 }
	RET
;     209 
;     210 // External Interrupt 0 service routine
;     211 interrupt [EXT_INT0] void __ext_int0_isr(void)
;     212 {
___ext_int0_isr:
	RCALL SUBOPT_0x1
;     213  TCNT0= 0; // 
	LDI  R30,LOW(0)
	OUT  0x32,R30
;     214  TCCR0 = k; //    
	OUT  0x33,R4
;     215 
;     216  TCNT1H= 0; //  pps
	RCALL SUBOPT_0x0
;     217  TCNT1L= 0;
;     218 
;     219  if (j) // 
	SBRS R2,0
	RJMP _0x1A
;     220     {
;     221 	 __segment_7 (i);
	ST   -Y,R5
	RCALL ___segment_7
;     222 
;     223 	 j = 0;
	CLT
	BLD  R2,0
;     224 	 };
_0x1A:
;     225  }
	RJMP _0x29
;     226 
;     227 // Timer 0 output compare interrupt service routine
;     228 interrupt [TIM0_COMP] void __timer0_comp_isr(void)
;     229 {
___timer0_comp_isr:
;     230  M_PPS = PPS;
	SBIC 0x10,2
	RJMP _0x1B
	CBI  0x18,7
	RJMP _0x1C
_0x1B:
	SBI  0x18,7
_0x1C:
;     231  }
	RETI
;     232 
;     233 // Timer 1 output compare A interrupt service routine*******************************
;     234 interrupt [TIM1_COMPA] void __timer1_compa_isr(void)
;     235 {
___timer1_compa_isr:
	RCALL SUBOPT_0x1
;     236 j ^=1; //   pps
	LDI  R30,0
	SBRC R2,0
	LDI  R30,1
	LDI  R26,LOW(1)
	EOR  R30,R26
	CALL __BSTB1
	BLD  R2,0
;     237 
;     238 if (j) // 
	SBRS R2,0
	RJMP _0x1D
;     239    {
;     240     __segment_7_off ();
	RCALL ___segment_7_off
;     241 	}
;     242 else {
	RJMP _0x1E
_0x1D:
;     243       __segment_7 (i);
	ST   -Y,R5
	RCALL ___segment_7
;     244 	  };
_0x1E:
;     245 
;     246 TCNT1H = 0; //  
	RCALL SUBOPT_0x0
;     247 TCNT1L = 0;
;     248 
;     249 TCCR1B = 0b00000101; //    8/1024 
	LDI  R30,LOW(5)
	OUT  0x2E,R30
;     250 } //*************************************************************************
_0x29:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;     251 
;     252 void main ()
;     253 {
_main:
;     254 __dig_init ();
	RCALL ___dig_init
;     255 
;     256 __io_init (); // /   0- 
	RCALL ___io_init
;     257 
;     258 __interrupt_init (); // 
	RCALL ___interrupt_init
;     259 #asm ("sei") //  
	sei
;     260 
;     261 while (1)
_0x1F:
;     262       {
;     263 	   if (!BUTTON) //  
	SBIC 0x10,3
	RJMP _0x22
;     264 	      {
;     265 		   #asm("cli") //   
	cli
;     266 
;     267 		   i++; // 
	INC  R5
;     268 
;     269 		   if (i == 16) // 16,   0- 
	LDI  R30,LOW(16)
	CP   R30,R5
	BRNE _0x23
;     270 		      {
;     271 			   i = 0;
	CLR  R5
;     272 			   };
_0x23:
;     273 
;     274 		   k = __routine (i); // 
	ST   -Y,R5
	RCALL ___routine
	MOV  R4,R30
;     275 
;     276 		   #asm ("sei") //  
	sei
;     277 
;     278 		   while (!BUTTON)
_0x24:
	SBIC 0x10,3
	RJMP _0x26
;     279 		         { //  
;     280                   delay_ms (100); //    
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;     281                   };
	RJMP _0x24
_0x26:
;     282            };
_0x22:
;     283 	   };
	JMP  _0x1F
;     284 }
_0x27:
	RJMP _0x27


;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x0:
	LDI  R30,LOW(0)
	OUT  0x2D,R30
	OUT  0x2C,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x1:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
	RET

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__BSTB1:
	CLT
	TST  R30
	BREQ PC+2
	SET
	RET

;END OF CODE MARKER
__END_OF_CODE:
