
#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb OCDR=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb OCR0=0X3c;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x40
	.EQU __sm_mask=0xB0
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0xA0
	.EQU __sm_ext_standby=0xB0
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm

#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

unsigned char dig[16]; 

char i, k; 

bit j; 

void __io_init () 
{
DDRA = 0b000; 
PORTA = 0b111;

DDRB = 0b01111111; 
PORTB  = dig[0];

DDRD = 0b1000000; 
PORTD = 0b1111111;

ACSR=0x80;
}

void __dig_init () 
{
dig[0] = 1    + 2    + 4    + 8  + 16   + 32  ;   
dig[1] = 2    + 4   ;           
dig[2] = 1    + 2    + 64   + 16   + 8 ;     
dig[3] = 1    + 2    + 64   + 4    + 8 ;     
dig[4] = 32   + 64   + 2    + 4   ;       
dig[5] = 1    + 32   + 64   + 4    + 8 ;     
dig[6] = 1    + 32   + 64   + 4    + 8  + 16  ;
dig[7] = 1    + 2    + 4   ;
dig[8] = 1    + 2    + 4    + 8  + 16   + 32   + 64  ;
dig[9] = 1    + 2    + 4    + 8  + 32   + 64  ;
dig[10] = 119; 
dig[11] = 124; 
dig[12] = 57;  
dig[13] = 94;  
dig[14] = 121; 
dig[15] = 113; 
}

void __segment_7 (char x) 
{
PORTB  = PORTB  & 0b10000000; 

PORTB  = PORTB  | dig [x]; 
} 

void __segment_7_off ()
{
PORTB  = PORTB  & 0b10000000; 
}

char __routine (char x) 
{

char k_l; 

switch (x)
{
case 0: DDRB.7 = 0; 
__segment_7 (0);
break;

case 1: __segment_7 (1);
break;

case 2: __segment_7 (2);
break;

case 3: __segment_7 (3);
break;

case 4: __segment_7 (4);
break;

case 5: __segment_7 (5);
break;

case 6: __segment_7 (6);
break;

case 7: __segment_7 (7);
break;

case 8: DDRB.7 = 1; 

__segment_7 (8);

OCR0=0x4F; 
k_l = 0x01; 
break;

case 9: __segment_7 (9);

OCR0=0x32; 
k_l = 0x02; 
break;

case 10: __segment_7 (10);

OCR0=0x63; 
k_l = 0x02; 
break;

case 11: __segment_7 (11);

OCR0=0x94; 
k_l = 0x02; 
break;

case 12: __segment_7 (12);

OCR0=0xC7; 
k_l = 0x02; 
break;

case 13: __segment_7 (13);

OCR0=0xF8; 
k_l = 0x02; 
break;

case 14: __segment_7 (14);

OCR0=0x25; 
k_l = 0x03;; 
break;

case 15: __segment_7 (15);

OCR0=0x2B; 
k_l = 0x03;; 
break;
};

return k_l;		
}

void __interrupt_init ()
{

GICR|=0x40;
MCUCR=0x03;
MCUCSR=0x00;
GIFR=0x40;

TIMSK = 0b00010010; 

TCNT1H = 0; 
TCNT1L = 0;

OCR1AH = 0x20; 
OCR1AL = 0x0b;

TCCR1B = 0b00000101; 
}

interrupt [2] void __ext_int0_isr(void)
{
TCNT0= 0; 
TCCR0 = k; 

TCNT1H= 0; 
TCNT1L= 0;

if (j) 
{
__segment_7 (i);

j = 0;
};
}

interrupt [20] void __timer0_comp_isr(void)
{
PORTB.7  = PIND.2    ;
}

interrupt [7] void __timer1_compa_isr(void)
{
j ^=1; 

if (j) 
{	   
__segment_7_off (); 
}
else {
__segment_7 (i);
};

TCNT1H = 0; 
TCNT1L = 0;

TCCR1B = 0b00000101; 
} 

void main ()
{
__dig_init ();

__io_init (); 

__interrupt_init (); 
#asm ("sei") 

while (1)
{
if (!PIND.3 ) 
{
#asm("cli") 

i++; 

if (i == 16) 
{
i = 0;
};

k = __routine (i); 

#asm ("sei") 

while (!PIND.3 )
{ 
delay_ms (100); 
};
};				     
};
}
